package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesBallTrackRuleService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesBallTrackRule;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/24 15:37
 * @Modify:
 **/
@Service
@Slf4j
public class MesBallTrackRuleServiceImpl extends BaseMesService<MesBallTrackRule> implements IMesBallTrackRuleService {

    @Override
    protected void setPackQueryBean(MesBallTrackRule bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getEquipmentCode(), "equipmentCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getBallTrackName(), "ballTrackName", packBean);
    }

    @Override
    protected void onInsertBean(MesBallTrackRule item) {
        ValidatorBean.checkNotNull(item.getBallTrackName(), "轨道名称不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
        ValidatorBean.checkNotNull(item.getEquipVariableValue(), "轨道变量值不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(), "equipmentCode", ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("轨道编码已存在");
        }
    }

    @Override
    protected void onUpdateBean(MesBallTrackRule item) {
        ValidatorBean.checkNotNull(item.getId(), "id不能为空");
        ValidatorBean.checkNotNull(item.getBallTrackName(), "轨道名称不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
        ValidatorBean.checkNotNull(item.getEquipVariableValue(), "轨道变量值不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(), "equipmentCode", ddlPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("轨道编码已存在");
        }
    }
}
